package com.liang.dao;

import com.liang.entity.SysUserInfo;
import io.swagger.models.auth.In;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (SysUserInfo)表数据库访问层
 *
 * @author makejava
 * @since 2023-02-19 21:37:39
 */
public interface SysUserInfoDao {

    /**
     * 通过ID查询单条数据
     *
     * @param userId 主键
     * @return 实例对象
     */
    SysUserInfo queryById(Integer userId);

    /**
     * 查询指定行数据
     *
     * @param sysUserInfo 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<SysUserInfo> queryAllByLimit(SysUserInfo sysUserInfo, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param sysUserInfo 查询条件
     * @return 总行数
     */
    long count(SysUserInfo sysUserInfo);

    /**
     * 新增数据
     *
     * @param sysUserInfo 实例对象
     * @return 影响行数
     */
    int insert(SysUserInfo sysUserInfo);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysUserInfo> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<SysUserInfo> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysUserInfo> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<SysUserInfo> entities);

    /**
     * 修改数据
     *
     * @param sysUserInfo 实例对象
     * @return 影响行数
     */
    int update(SysUserInfo sysUserInfo);

    /**
     * 通过主键删除数据
     *
     * @param userId 主键
     * @return 影响行数
     */
    int deleteById(Integer userId, Integer updateUser);

    /**
     * 获取用户列表
     *
     * @param map
     * @return
     */
    List<SysUserInfo> getSysUserInfoList(Map map);

    /**
     * 获取岗位列表
     */

    List<SysUserInfo> getGw(Map map);
    /**
     * 获取用户
     *
     * @param map
     * @return
     */
    SysUserInfo getSysUserInfo(Map map);

    /**
     * 批量删除系统用户
     *
     * @param
     * @return
     */
    int batchDelete(List<Integer> userIdList, Integer updateUser);

    /**
     * 删除一个系统用户
     *
     * @param userId
     * @return
     */
    int delete(Integer userId);

    /**
     * 校验用户账号是否唯一
     *
     * @param account 用户账号
     * @return
     */
    int checkUserNameUnique(@Param("account") String account);

    /**
     * 新增用户
     *
     * @param userInfo
     * @return
     */
    int doAdd(SysUserInfo userInfo);

    /**
     * 用户修改
     *
     * @param userInfo
     * @return
     */
    int doUpdate(SysUserInfo userInfo);

    /**
     * 用户密码重置
     *
     * @param userInfo
     * @return
     */
    int resetPass(SysUserInfo userInfo);

    /**
     * 通过id获取一条记录
     *
     * @param userId
     * @return
     */
    SysUserInfo getOneById(Integer userId);

    /**
     * 获取创建人
     *
     * @return
     */
    List<Map<String, String>> getCJR();

    /**
     * 通过account获取一条记录
     *
     * @param account
     * @return
     */
    List<SysUserInfo> getUserByAccount(String account);

    /**
     * 根据登录信息查询所属部门名称
     *
     * @param dept_id 部门id
     * @return
     */
    String getDeptNameByAccount(String dept_id);

    /**
     * 根据登录id查询岗位名称
     *
     * @param userId
     * @return
     */
    List<String> getPostNameByUserId(Integer userId);

    /**
     * 获取Id人员的岗位信息
     */
    List<SysUserInfo> getDept(Integer id);


    /**
     * 获取全部部门数据
     */
    List<SysUserInfo> getDeptName();

    String getBzs(Integer id);
}




